diff -u -r icu/source/i18n/regexcmp.cpp icu.new/source/i18n/regexcmp.cpp
--- icu/source/i18n/regexcmp.cpp	2004-12-30 07:25:50.000000000 +0000
+++ icu.new/source/i18n/regexcmp.cpp	2006-08-10 14:51:46.000000000 +0100
@@ -1860,6 +2349,13 @@
             //  as the last operand of the URX_LBN_CONT
             op = URX_BUILD(URX_RELOC_OPRND, fRXPat->fCompiledPat->size());
             fRXPat->fCompiledPat->setElementAt(op,  fMatchOpenParen-1);
+
+            if (patIdx == lookBehindNCE) {
+                // For conditional expressions, append a STATE_POP to remove the extra
+                // stack frame.
+                op = URX_BUILD(URX_STATE_POP, 0);
+                fRXPat->fCompiledPat->addElement(op, *fStatus);
+            }
         }
         break;
 
@@ -2108,6 +2604,7 @@
         case URX_END:
         case URX_STRING_LEN:
         case URX_NOP:
+        case URX_STATE_POP:
         case URX_START_CAPTURE:
         case URX_END_CAPTURE:
         case URX_BACKSLASH_B:
@@ -2270,6 +2767,17 @@
             atStart = FALSE;
             break;
 
+        case URX_CONDITION:
+            {
+                int32_t skipDest = loc + 2;
+
+                U_ASSERT(skipDest <= end + 1);
+                // Propagate the current min length to the target loc of the skip
+                if (forwardedLength.elementAti(skipDest) > currentLen) {
+                    forwardedLength.setElementAt(currentLen, skipDest);
+                }
+            }
+            break;
 
         case URX_JMPX:
             loc++;             // Except for extra operand on URX_JMPX, same as URX_JMP.
@@ -2579,6 +3087,7 @@
         case URX_END:
         case URX_STRING_LEN:
         case URX_NOP:
+        case URX_STATE_POP:
         case URX_START_CAPTURE:
         case URX_END_CAPTURE:
         case URX_BACKSLASH_B:
@@ -2619,6 +3128,17 @@
             currentLen++;
             break;
 
+        case URX_CONDITION:
+            {
+                int32_t skipDest = loc + 2;
+
+                U_ASSERT(skipDest <= end + 1);
+                // Propagate the current min length to the target loc of the skip
+                if (forwardedLength.elementAti(skipDest) > currentLen) {
+                    forwardedLength.setElementAt(currentLen, skipDest);
+                }
+            }
+            break;
 
         case URX_JMPX:
             loc++;              // URX_JMPX has an extra operand, ignored here,
@@ -2819,6 +3339,7 @@
         case URX_END:
         case URX_STRING_LEN:
         case URX_NOP:
+        case URX_STATE_POP:
         case URX_START_CAPTURE:
         case URX_END_CAPTURE:
         case URX_BACKSLASH_B:
@@ -2876,6 +3397,22 @@
             }
             break;
 
+            // Conditional skip operation.  A bit like a jump.
+            //
+        case URX_CONDITION:
+            {
+                int32_t skipDest = loc + 2;
+                
+                U_ASSERT(skipDest <= end + 1);
+                // Propagate the current max length
+                if (forwardedLength.elementAti(skipDest) < currentLen) {
+                    forwardedLength.setElementAt(currentLen, skipDest);
+                }
+                // N.B. Don't reset currentLen here; if the condition isn't met, we will continue
+                //      matching at the next instruction.
+            }
+            break;
+
             // Jumps.  
             //
         case URX_JMP:
@@ -2888,7 +3425,7 @@
                     // Loop of some kind.  Max match length is unbounded.
                     currentLen = INT32_MAX;
                 } else {
-                    // Forward jump.  Propagate the current min length to the target loc of the jump.
+                    // Forward jump.  Propagate the current max length to the target loc of the jump.
                     if (forwardedLength.elementAti(jmpDest) < currentLen) {
                         forwardedLength.setElementAt(currentLen, jmpDest);
                     }
@@ -3061,6 +3598,8 @@
                 break;
             }
 
+        case URX_STATE_POP:
+        case URX_CONDITION:
         case URX_RESERVED_OP:
         case URX_RESERVED_OP_N:
         case URX_BACKTRACK:
@@ -3247,7 +3786,9 @@
 static const UChar      chUpperN    = 0x4E;
 static const UChar      chLowerP    = 0x70;
 static const UChar      chUpperP    = 0x50;
-
+static const UChar      chLAngle    = 0x3c;     // '<'
+static const UChar      chEquals    = 0x3d;     // '='
+static const UChar      chRAngle    = 0x3e;     // '>'
 
 //------------------------------------------------------------------------------
 //
@@ -3527,6 +4068,72 @@
     return uset;
 }
 
+
+//------------------------------------------------------------------------------
+//
+//  scanName   Scan the name for a named group, e.g. (?P<name>foo), a named
+//             backreference, e.g. (?P=name).
+//
+//             Case 1: Named group
+//             The scan position will be at the '<'.  On return, the scan
+//             position should be just after the '>'.
+//
+//             Case 2: Named backreference
+//             The scan position will be at the '='.  On return the scan
+//             position should be just after the ')'.
+//
+//             Case 3: Conditional reference
+//             The scan position will be *after* the '('.  On return, the scan
+//             position should be just after the ')'.
+//
+//             Return a UnicodeString containing the name, or NULL if the
+//             pattern is invalid.
+//
+//------------------------------------------------------------------------------
+UnicodeString *RegexCompile::scanName(UBool isCondition)
+{
+    UnicodeString *ustr = NULL;
+    UChar32       chTerm;
+
+    if (U_FAILURE(*fStatus)) {
+        return NULL;
+    }
+
+    if (!isCondition) {
+        U_ASSERT(fC.fChar == chLAngle || fC.fChar == chEquals);
+
+        if (fC.fChar == chLAngle)
+            chTerm = chRAngle;
+        else
+            chTerm = chRParen;
+
+        nextChar(fC);
+    } else {
+        chTerm = chRParen;
+    }
+
+    UnicodeString *name = new UnicodeString();
+    UChar32       ch;
+    if (!name) {
+        error(U_MEMORY_ALLOCATION_ERROR);
+        return NULL;
+    }
+    do {
+        ch = fC.fChar;
+        if (ch == -1) {
+            // Hit the end of the input string without finding the closing
+            // character
+            error(U_REGEX_UNTERMINATED_GROUP_NAME);
+            return NULL;
+        }
+        if (ch != chTerm)
+            name->append (ch);
+        nextChar(fC);
+    } while (ch != chTerm);
+
+    return name;
+}
+
 U_NAMESPACE_END
 #endif  // !UCONFIG_NO_REGULAR_EXPRESSIONS
 
diff -u -r icu/source/i18n/regexcmp.h icu.new/source/i18n/regexcmp.h
--- icu/source/i18n/regexcmp.h	2003-04-03 00:10:16.000000000 +0100
+++ icu.new/source/i18n/regexcmp.h	2006-08-10 00:20:43.000000000 +0100
@@ -28,6 +28,17 @@
 U_NAMESPACE_BEGIN
 
 
+//
+//  Special mode flags, used during compilation only
+//
+enum {
+    URX_USER_MODE_FLAGS     = 0x00ffffff,
+    URX_RESERVED_MODE_FLAGS = ~URX_USER_MODE_FLAGS,
+
+    URX_INSIDE_CONDITIONAL  = 0x80000000, // If set, we're inside a conditional expression
+    URX_GOT_COND_ELSE       = 0x40000000, // If set, we've already seen the '|'
+};
+
 //--------------------------------------------------------------------------------
 //
 //  class RegexCompile    Contains the regular expression compiler.
@@ -70,14 +81,22 @@
     //   The category is saved in the compile-time parentheses stack frame, and
     //   determines the code to be generated when the matching close ) is encountered.
     enum EParenClass {
-        plain        = -1,               // No special handling
-        capturing    = -2, 
-        atomic       = -3,
-        lookAhead    = -4,
-        negLookAhead = -5,
-        flags        = -6,
-        lookBehind   = -7,
-        lookBehindN  = -8
+        plain         = -1,               // No special handling
+        capturing     = -2, 
+        atomic        = -3,
+        lookAhead     = -4,
+        negLookAhead  = -5,
+        flags         = -6,
+        lookBehind    = -7,
+        lookBehindN   = -8,
+        conditional   = -9,
+        condWithMatch = -10,              // A conditional that uses a lookahead/lookbehind
+
+        // Used when these appear in the test part of a conditional
+        lookAheadCE    = -11,
+        negLookAheadCE = -12,
+        lookBehindCE   = -13,
+        lookBehindNCE  = -14
     };
 
 private:
@@ -90,6 +109,7 @@
     UChar32     peekCharLL();
     UnicodeSet  *scanSet();
     UnicodeSet  *scanProp();
+    UnicodeString *scanName(UBool isCondition = FALSE);
     void        handleCloseParen();
     int32_t     blockTopLoc(UBool reserve);          // Locate a position in the compiled pattern
                                                      //  at the top of the just completed block
@@ -154,6 +174,8 @@
     //  Data associated with the generation of the pcode for the match engine
     //
     int32_t                       fModeFlags;        // Match Flags.  (Case Insensitive, etc.)
+                                                     //   This also gets used to hold some state info
+                                                     //   for conditional exprs (in the high byte)
     int32_t                       fNewModeFlags;     // New flags, while compiling (?i, holds state
                                                      //   until last flag is scanned.
     UBool                         fSetModeFlag;      // true for (?ismx, false for (?-ismx
@@ -175,7 +197,6 @@
                                                      //   the kind of paren that opened the frame.  Some
                                                      //   need special handling on close.
 
-
     int32_t                       fMatchOpenParen;   // The position in the compiled pattern
                                                      //   of the slot reserved for a state save
                                                      //   at the start of the most recently processed
diff -u -r icu/source/i18n/regexcst.h icu.new/source/i18n/regexcst.h
--- icu/source/i18n/regexcst.h	2003-11-08 02:01:42.000000000 +0000
+++ icu.new/source/i18n/regexcst.h	2006-08-10 15:25:15.000000000 +0100
@@ -16,75 +16,82 @@
 //
 // Character classes for regex pattern scanning.
 //
-    static const uint8_t kRuleSet_digit_char = 128;
-    static const uint8_t kRuleSet_white_space = 129;
+    static const uint8_t kRuleSet_white_space = 128;
+    static const uint8_t kRuleSet_digit_char = 129;
     static const uint8_t kRuleSet_rule_char = 130;
 
 
 enum Regex_PatternParseAction {
-    doPossessivePlus,
-    doCloseParen,
-    doProperty,
-    doBeginMatchMode,
-    doOrOperator,
-    doOpenCaptureParen,
-    doBadOpenParenType,
-    doRuleError,
+    doLiteralChar,
+    doBackslashA,
+    doNOP,
+    doBackslashG,
+    doPerlInline,
+    doPyNamedBackRef,
     doIntevalLowerDigit,
-    doBackslashs,
-    doNGOpt,
-    doBackslashw,
-    doMismatchedParenErr,
-    doOpenLookBehind,
-    doBackslashz,
+    doProperty,
+    doBackslashX,
+    doOpenAtomicParen,
+    doOpenPyNamedParen,
+    doPatFinish,
+    doUnimplCondition,
+    doNGPlus,
+    doOpenLookBehindNeg,
     doIntervalError,
-    doStar,
-    doCaret,
-    doEnterQuoteMode,
-    doNGStar,
-    doMatchMode,
-    doIntervalUpperDigit,
-    doOpenLookAheadNeg,
+    doIntervalSame,
+    doBackRef,
     doPlus,
+    doOpenCaptureParen,
+    doMismatchedParenErr,
+    doBeginMatchMode,
+    doEscapeError,
     doOpenNonCaptureParen,
-    doBackslashA,
-    doBackslashB,
-    doNGPlus,
+    doDollar,
+    doIntervalUpperDigit,
+    doBackslashs,
     doSetMatchMode,
-    doPatFinish,
-    doBackslashD,
-    doPossessiveInterval,
-    doEscapeError,
-    doBackslashG,
-    doSuppressComments,
+    doOpenLookBehind,
     doMatchModeParen,
+    doOrOperator,
+    doCaret,
+    doStar,
     doOpt,
-    doInterval,
-    doLiteralChar,
-    doIntervalInit,
-    doOpenAtomicParen,
-    doBackslashS,
-    doOpenLookAhead,
-    doBackRef,
-    doDollar,
-    doDotAny,
+    doMatchMode,
+    doSuppressComments,
+    doPossessiveInterval,
+    doOpenLookAheadNeg,
     doBackslashW,
-    doBackslashX,
+    doCloseParen,
+    doIntervalInit,
     doScanUnicodeSet,
-    doBackslashZ,
-    doPerlInline,
+    doNGStar,
+    doEnterQuoteMode,
+    doBackslashB,
+    doBackslashw,
     doPossessiveOpt,
-    doNOP,
+    doRuleError,
+    doBackslashb,
+    doCondOpenLookBehindNeg,
     doConditionalExpr,
-    doExit,
+    doCondOpenLookAheadNeg,
+    doPossessivePlus,
+    doBadOpenParenType,
     doNGInterval,
+    doBackslashd,
+    doBackslashD,
+    doCondOpenLookBehind,
+    doExit,
+    doInterval,
+    doNGOpt,
+    doBackslashZ,
+    doBackslashS,
+    doOpenLookAhead,
     doPatStart,
     doBadModeFlag,
-    doBackslashb,
     doPossessiveStar,
-    doBackslashd,
-    doIntervalSame,
-    doOpenLookBehindNeg,
+    doBackslashz,
+    doCondOpenLookAhead,
+    doDotAny,
     rbbiLastAction};
 
 //-------------------------------------------------------------------------------
@@ -112,15 +119,15 @@
     , {doDotAny, 46 /* . */, 14,0,  TRUE}     //  6 
     , {doCaret, 94 /* ^ */, 2,0,  TRUE}     //  7 
     , {doDollar, 36 /* $ */, 2,0,  TRUE}     //  8 
-    , {doNOP, 92 /* \ */, 81,0,  TRUE}     //  9 
+    , {doNOP, 92 /* \ */, 93,0,  TRUE}     //  9 
     , {doOrOperator, 124 /* | */, 2,0,  TRUE}     //  10 
     , {doCloseParen, 41 /* ) */, 255,0,  TRUE}     //  11 
     , {doPatFinish, 253, 2,0,  FALSE}     //  12 
-    , {doRuleError, 255, 101,0,  FALSE}     //  13 
-    , {doNOP, 42 /* * */, 59,0,  TRUE}     //  14      expr-quant
-    , {doNOP, 43 /* + */, 62,0,  TRUE}     //  15 
-    , {doNOP, 63 /* ? */, 65,0,  TRUE}     //  16 
-    , {doIntervalInit, 123 /* { */, 68,0,  TRUE}     //  17 
+    , {doRuleError, 255, 113,0,  FALSE}     //  13 
+    , {doNOP, 42 /* * */, 71,0,  TRUE}     //  14      expr-quant
+    , {doNOP, 43 /* + */, 74,0,  TRUE}     //  15 
+    , {doNOP, 63 /* ? */, 77,0,  TRUE}     //  16 
+    , {doIntervalInit, 123 /* { */, 80,0,  TRUE}     //  17 
     , {doNOP, 40 /* ( */, 23,0,  TRUE}     //  18 
     , {doNOP, 255, 20,0,  FALSE}     //  19 
     , {doOrOperator, 124 /* | */, 2,0,  TRUE}     //  20      expr-cont
@@ -128,7 +135,7 @@
     , {doNOP, 255, 2,0,  FALSE}     //  22 
     , {doSuppressComments, 63 /* ? */, 25,0,  TRUE}     //  23      open-paren-quant
     , {doNOP, 255, 27,0,  FALSE}     //  24 
-    , {doNOP, 35 /* # */, 47, 14, TRUE}     //  25      open-paren-quant2
+    , {doNOP, 35 /* # */, 59, 14, TRUE}     //  25      open-paren-quant2
     , {doNOP, 255, 29,0,  FALSE}     //  26 
     , {doSuppressComments, 63 /* ? */, 29,0,  TRUE}     //  27      open-paren
     , {doOpenCaptureParen, 255, 2, 14, FALSE}     //  28 
@@ -136,75 +143,87 @@
     , {doOpenAtomicParen, 62 /* > */, 2, 14, TRUE}     //  30 
     , {doOpenLookAhead, 61 /* = */, 2, 20, TRUE}     //  31 
     , {doOpenLookAheadNeg, 33 /* ! */, 2, 20, TRUE}     //  32 
-    , {doNOP, 60 /* < */, 44,0,  TRUE}     //  33 
-    , {doNOP, 35 /* # */, 47, 2, TRUE}     //  34 
-    , {doBeginMatchMode, 105 /* i */, 50,0,  FALSE}     //  35 
-    , {doBeginMatchMode, 109 /* m */, 50,0,  FALSE}     //  36 
-    , {doBeginMatchMode, 115 /* s */, 50,0,  FALSE}     //  37 
-    , {doBeginMatchMode, 119 /* w */, 50,0,  FALSE}     //  38 
-    , {doBeginMatchMode, 120 /* x */, 50,0,  FALSE}     //  39 
-    , {doBeginMatchMode, 45 /* - */, 50,0,  FALSE}     //  40 
-    , {doConditionalExpr, 40 /* ( */, 101,0,  TRUE}     //  41 
-    , {doPerlInline, 123 /* { */, 101,0,  TRUE}     //  42 
-    , {doBadOpenParenType, 255, 101,0,  FALSE}     //  43 
-    , {doOpenLookBehind, 61 /* = */, 2, 20, TRUE}     //  44      open-paren-lookbehind
-    , {doOpenLookBehindNeg, 33 /* ! */, 2, 20, TRUE}     //  45 
-    , {doBadOpenParenType, 255, 101,0,  FALSE}     //  46 
-    , {doNOP, 41 /* ) */, 255,0,  TRUE}     //  47      paren-comment
-    , {doMismatchedParenErr, 253, 101,0,  FALSE}     //  48 
-    , {doNOP, 255, 47,0,  TRUE}     //  49 
-    , {doMatchMode, 105 /* i */, 50,0,  TRUE}     //  50      paren-flag
-    , {doMatchMode, 109 /* m */, 50,0,  TRUE}     //  51 
-    , {doMatchMode, 115 /* s */, 50,0,  TRUE}     //  52 
-    , {doMatchMode, 119 /* w */, 50,0,  TRUE}     //  53 
-    , {doMatchMode, 120 /* x */, 50,0,  TRUE}     //  54 
-    , {doMatchMode, 45 /* - */, 50,0,  TRUE}     //  55 
-    , {doSetMatchMode, 41 /* ) */, 2,0,  TRUE}     //  56 
-    , {doMatchModeParen, 58 /* : */, 2, 14, TRUE}     //  57 
-    , {doBadModeFlag, 255, 101,0,  FALSE}     //  58 
-    , {doNGStar, 63 /* ? */, 20,0,  TRUE}     //  59      quant-star
-    , {doPossessiveStar, 43 /* + */, 20,0,  TRUE}     //  60 
-    , {doStar, 255, 20,0,  FALSE}     //  61 
-    , {doNGPlus, 63 /* ? */, 20,0,  TRUE}     //  62      quant-plus
-    , {doPossessivePlus, 43 /* + */, 20,0,  TRUE}     //  63 
-    , {doPlus, 255, 20,0,  FALSE}     //  64 
-    , {doNGOpt, 63 /* ? */, 20,0,  TRUE}     //  65      quant-opt
-    , {doPossessiveOpt, 43 /* + */, 20,0,  TRUE}     //  66 
-    , {doOpt, 255, 20,0,  FALSE}     //  67 
-    , {doNOP, 129, 68,0,  TRUE}     //  68      interval-open
-    , {doNOP, 128, 71,0,  FALSE}     //  69 
-    , {doIntervalError, 255, 101,0,  FALSE}     //  70 
-    , {doIntevalLowerDigit, 128, 71,0,  TRUE}     //  71      interval-lower
-    , {doNOP, 44 /* , */, 75,0,  TRUE}     //  72 
-    , {doIntervalSame, 125 /* } */, 78,0,  TRUE}     //  73 
-    , {doIntervalError, 255, 101,0,  FALSE}     //  74 
-    , {doIntervalUpperDigit, 128, 75,0,  TRUE}     //  75      interval-upper
-    , {doNOP, 125 /* } */, 78,0,  TRUE}     //  76 
-    , {doIntervalError, 255, 101,0,  FALSE}     //  77 
-    , {doNGInterval, 63 /* ? */, 20,0,  TRUE}     //  78      interval-type
-    , {doPossessiveInterval, 43 /* + */, 20,0,  TRUE}     //  79 
-    , {doInterval, 255, 20,0,  FALSE}     //  80 
-    , {doBackslashA, 65 /* A */, 2,0,  TRUE}     //  81      backslash
-    , {doBackslashB, 66 /* B */, 2,0,  TRUE}     //  82 
-    , {doBackslashb, 98 /* b */, 2,0,  TRUE}     //  83 
-    , {doBackslashd, 100 /* d */, 14,0,  TRUE}     //  84 
-    , {doBackslashD, 68 /* D */, 14,0,  TRUE}     //  85 
-    , {doBackslashG, 71 /* G */, 2,0,  TRUE}     //  86 
-    , {doProperty, 78 /* N */, 14,0,  FALSE}     //  87 
-    , {doProperty, 112 /* p */, 14,0,  FALSE}     //  88 
-    , {doProperty, 80 /* P */, 14,0,  FALSE}     //  89 
-    , {doEnterQuoteMode, 81 /* Q */, 2,0,  TRUE}     //  90 
-    , {doBackslashS, 83 /* S */, 14,0,  TRUE}     //  91 
-    , {doBackslashs, 115 /* s */, 14,0,  TRUE}     //  92 
-    , {doBackslashW, 87 /* W */, 14,0,  TRUE}     //  93 
-    , {doBackslashw, 119 /* w */, 14,0,  TRUE}     //  94 
-    , {doBackslashX, 88 /* X */, 14,0,  TRUE}     //  95 
-    , {doBackslashZ, 90 /* Z */, 2,0,  TRUE}     //  96 
-    , {doBackslashz, 122 /* z */, 2,0,  TRUE}     //  97 
-    , {doBackRef, 128, 14,0,  TRUE}     //  98 
-    , {doEscapeError, 253, 101,0,  FALSE}     //  99 
-    , {doLiteralChar, 255, 14,0,  TRUE}     //  100 
-    , {doExit, 255, 101,0,  TRUE}     //  101      errorDeath
+    , {doNOP, 60 /* < */, 45,0,  TRUE}     //  33 
+    , {doNOP, 35 /* # */, 59, 2, TRUE}     //  34 
+    , {doBeginMatchMode, 105 /* i */, 62,0,  FALSE}     //  35 
+    , {doBeginMatchMode, 109 /* m */, 62,0,  FALSE}     //  36 
+    , {doBeginMatchMode, 115 /* s */, 62,0,  FALSE}     //  37 
+    , {doBeginMatchMode, 119 /* w */, 62,0,  FALSE}     //  38 
+    , {doBeginMatchMode, 120 /* x */, 62,0,  FALSE}     //  39 
+    , {doBeginMatchMode, 45 /* - */, 62,0,  FALSE}     //  40 
+    , {doNOP, 40 /* ( */, 48,0,  TRUE}     //  41 
+    , {doPerlInline, 123 /* { */, 113,0,  TRUE}     //  42 
+    , {doNOP, 80 /* P */, 57,0,  TRUE}     //  43 
+    , {doBadOpenParenType, 255, 113,0,  FALSE}     //  44 
+    , {doOpenLookBehind, 61 /* = */, 2, 20, TRUE}     //  45      open-paren-lookbehind
+    , {doOpenLookBehindNeg, 33 /* ! */, 2, 20, TRUE}     //  46 
+    , {doBadOpenParenType, 255, 113,0,  FALSE}     //  47 
+    , {doNOP, 63 /* ? */, 50, 14, TRUE}     //  48      open-paren-cond
+    , {doConditionalExpr, 255, 2, 14, FALSE}     //  49 
+    , {doCondOpenLookAhead, 61 /* = */, 2, 2, TRUE}     //  50      open-paren-cond-ext
+    , {doCondOpenLookAheadNeg, 33 /* ! */, 2, 2, TRUE}     //  51 
+    , {doNOP, 60 /* < */, 54,0,  TRUE}     //  52 
+    , {doUnimplCondition, 255, 113,0,  FALSE}     //  53 
+    , {doCondOpenLookBehind, 61 /* = */, 2, 2, TRUE}     //  54      open-paren-cond-lb
+    , {doCondOpenLookBehindNeg, 33 /* ! */, 2, 2, TRUE}     //  55 
+    , {doUnimplCondition, 255, 113,0,  FALSE}     //  56 
+    , {doOpenPyNamedParen, 60 /* < */, 2, 14, FALSE}     //  57      paren-python
+    , {doPyNamedBackRef, 61 /* = */, 14,0,  FALSE}     //  58 
+    , {doNOP, 41 /* ) */, 255,0,  TRUE}     //  59      paren-comment
+    , {doMismatchedParenErr, 253, 113,0,  FALSE}     //  60 
+    , {doNOP, 255, 59,0,  TRUE}     //  61 
+    , {doMatchMode, 105 /* i */, 62,0,  TRUE}     //  62      paren-flag
+    , {doMatchMode, 109 /* m */, 62,0,  TRUE}     //  63 
+    , {doMatchMode, 115 /* s */, 62,0,  TRUE}     //  64 
+    , {doMatchMode, 119 /* w */, 62,0,  TRUE}     //  65 
+    , {doMatchMode, 120 /* x */, 62,0,  TRUE}     //  66 
+    , {doMatchMode, 45 /* - */, 62,0,  TRUE}     //  67 
+    , {doSetMatchMode, 41 /* ) */, 2,0,  TRUE}     //  68 
+    , {doMatchModeParen, 58 /* : */, 2, 14, TRUE}     //  69 
+    , {doBadModeFlag, 255, 113,0,  FALSE}     //  70 
+    , {doNGStar, 63 /* ? */, 20,0,  TRUE}     //  71      quant-star
+    , {doPossessiveStar, 43 /* + */, 20,0,  TRUE}     //  72 
+    , {doStar, 255, 20,0,  FALSE}     //  73 
+    , {doNGPlus, 63 /* ? */, 20,0,  TRUE}     //  74      quant-plus
+    , {doPossessivePlus, 43 /* + */, 20,0,  TRUE}     //  75 
+    , {doPlus, 255, 20,0,  FALSE}     //  76 
+    , {doNGOpt, 63 /* ? */, 20,0,  TRUE}     //  77      quant-opt
+    , {doPossessiveOpt, 43 /* + */, 20,0,  TRUE}     //  78 
+    , {doOpt, 255, 20,0,  FALSE}     //  79 
+    , {doNOP, 128, 80,0,  TRUE}     //  80      interval-open
+    , {doNOP, 129, 83,0,  FALSE}     //  81 
+    , {doIntervalError, 255, 113,0,  FALSE}     //  82 
+    , {doIntevalLowerDigit, 129, 83,0,  TRUE}     //  83      interval-lower
+    , {doNOP, 44 /* , */, 87,0,  TRUE}     //  84 
+    , {doIntervalSame, 125 /* } */, 90,0,  TRUE}     //  85 
+    , {doIntervalError, 255, 113,0,  FALSE}     //  86 
+    , {doIntervalUpperDigit, 129, 87,0,  TRUE}     //  87      interval-upper
+    , {doNOP, 125 /* } */, 90,0,  TRUE}     //  88 
+    , {doIntervalError, 255, 113,0,  FALSE}     //  89 
+    , {doNGInterval, 63 /* ? */, 20,0,  TRUE}     //  90      interval-type
+    , {doPossessiveInterval, 43 /* + */, 20,0,  TRUE}     //  91 
+    , {doInterval, 255, 20,0,  FALSE}     //  92 
+    , {doBackslashA, 65 /* A */, 2,0,  TRUE}     //  93      backslash
+    , {doBackslashB, 66 /* B */, 2,0,  TRUE}     //  94 
+    , {doBackslashb, 98 /* b */, 2,0,  TRUE}     //  95 
+    , {doBackslashd, 100 /* d */, 14,0,  TRUE}     //  96 
+    , {doBackslashD, 68 /* D */, 14,0,  TRUE}     //  97 
+    , {doBackslashG, 71 /* G */, 2,0,  TRUE}     //  98 
+    , {doProperty, 78 /* N */, 14,0,  FALSE}     //  99 
+    , {doProperty, 112 /* p */, 14,0,  FALSE}     //  100 
+    , {doProperty, 80 /* P */, 14,0,  FALSE}     //  101 
+    , {doEnterQuoteMode, 81 /* Q */, 2,0,  TRUE}     //  102 
+    , {doBackslashS, 83 /* S */, 14,0,  TRUE}     //  103 
+    , {doBackslashs, 115 /* s */, 14,0,  TRUE}     //  104 
+    , {doBackslashW, 87 /* W */, 14,0,  TRUE}     //  105 
+    , {doBackslashw, 119 /* w */, 14,0,  TRUE}     //  106 
+    , {doBackslashX, 88 /* X */, 14,0,  TRUE}     //  107 
+    , {doBackslashZ, 90 /* Z */, 2,0,  TRUE}     //  108 
+    , {doBackslashz, 122 /* z */, 2,0,  TRUE}     //  109 
+    , {doBackRef, 129, 14,0,  TRUE}     //  110 
+    , {doEscapeError, 253, 113,0,  FALSE}     //  111 
+    , {doLiteralChar, 255, 14,0,  TRUE}     //  112 
+    , {doExit, 255, 113,0,  TRUE}     //  113      errorDeath
  };
 static const char * const RegexStateNames[] = {    0,
      "start",
@@ -250,9 +269,21 @@
     0,
     0,
     0,
+    0,
      "open-paren-lookbehind",
     0,
     0,
+     "open-paren-cond",
+    0,
+     "open-paren-cond-ext",
+    0,
+    0,
+    0,
+     "open-paren-cond-lb",
+    0,
+    0,
+     "paren-python",
+    0,
      "paren-comment",
     0,
     0,
diff -u -r icu/source/i18n/regeximp.h icu.new/source/i18n/regeximp.h
--- icu/source/i18n/regeximp.h	2004-12-30 07:25:50.000000000 +0000
+++ icu.new/source/i18n/regeximp.h	2006-08-10 00:53:23.000000000 +0100
@@ -168,10 +168,20 @@
                                //   Operand value:
                                //      0:  Normal (. doesn't match new-line) mode.
                                //      1:  . matches new-line mode.
-     URX_BACKSLASH_BU  = 53    // \b or \B in UREGEX_UWORD mode, using Unicode style
+     URX_BACKSLASH_BU  = 53,   // \b or \B in UREGEX_UWORD mode, using Unicode style
                                //   word boundaries.
-
-};           
+     URX_NAMED_BACKREF = 54,   // A named back-reference; this gets replaced with a normal
+                               // back-reference during compilation.  Operand is the name index.
+     URX_NMD_BACKREF_I = 55,   // Case insensitive named back-reference.
+     URX_CONDITION     = 56,   // A conditional skip; only matches if the specified group has been
+                               // matched.  If it has, skips the next instruction.
+                               //   Parameter is the index of the capture group variables in
+                               //   the state stack frame.
+     URX_NAMED_CONDTN  = 57,   // Like URX_NAMED_BACKREF, this is replaced during compilation.
+                               //   Parameter is the name index of the name.
+     URX_STATE_POP     = 58    // Pop a saved state from the stack without backtracking.
+                               //   Basically just cancels the last STATE_SAVE.
+};
 
 // Keep this list of opcode names in sync with the above enum
 //   Used for debug printing only.
@@ -229,8 +239,12 @@
         "LOOP_SR_I",           \
         "LOOP_C",              \
         "LOOP_DOT_I",          \
-        "BACKSLASH_BU"
-
+        "BACKSLASH_BU",        \
+        "NAMED_BACKREF",       \
+        "NAMED_BACKREF_I",     \
+        "CONDITION",           \
+        "NAMED_CONDITION",     \
+        "STATE_POP"
 
 //
 //  Convenience macros for assembling and disassembling a compiled operation.
diff -u -r icu/source/i18n/rematch.cpp icu.new/source/i18n/rematch.cpp
--- icu/source/i18n/rematch.cpp	2005-06-17 01:42:54.000000000 +0100
+++ icu.new/source/i18n/rematch.cpp	2006-08-10 00:51:33.000000000 +0100
@@ -96,7 +96,6 @@
     if (U_FAILURE(status)) {
         return;
     }
-
     if (fPattern->fDataSize > (int32_t)(sizeof(fSmallData)/sizeof(int32_t))) {
         fData = (int32_t *)uprv_malloc(fPattern->fDataSize * sizeof(int32_t)); 
     }
@@ -299,6 +298,31 @@
 
 
 
+int32_t RegexMatcher::end(const UnicodeString &groupName, UErrorCode &err) const {
+    if (U_FAILURE(err)) {
+        return -1;
+    }
+    if (fMatch == FALSE) {
+        err = U_REGEX_INVALID_STATE;
+        return -1;
+    }
+
+    int32_t namedGroupCount = fPattern->fNamedGroups->size();
+    int32_t nameIndex;
+    for (nameIndex = 0; nameIndex < namedGroupCount; ++nameIndex) {
+        UnicodeString *name = (UnicodeString *)fPattern->fNamedGroups->elementAt(nameIndex);
+
+        if (*name == groupName) {
+            int32_t groupNum = fPattern->fNamedGroupMap->elementAti(nameIndex);
+            return end(groupNum + 1, err);
+        }
+    }
+
+    err = U_REGEX_UNKNOWN_GROUP_NAME;
+    return -1;
+}
+
+
 //--------------------------------------------------------------------------------
 //
 //   find()
@@ -541,6 +565,48 @@
 }
 
 
+UnicodeString RegexMatcher::group(const UnicodeString &groupName,
+                                  UErrorCode &status) const {
+    if (U_FAILURE(status)) {
+        return UnicodeString();
+    }
+    if (U_FAILURE(fDeferredStatus)) {
+        status = fDeferredStatus;
+        return UnicodeString();
+    }
+    if (fMatch == FALSE) {
+        status = U_REGEX_INVALID_STATE;
+        return UnicodeString();
+    }
+
+    int32_t namedGroupCount = fPattern->fNamedGroups->size();
+    int32_t nameIndex;
+    for (nameIndex = 0; nameIndex < namedGroupCount; ++nameIndex) {
+        UnicodeString *name = (UnicodeString *)fPattern->fNamedGroups->elementAt(nameIndex);
+
+        if (*name == groupName) {
+            int32_t groupNum = fPattern->fNamedGroupMap->elementAti(nameIndex);
+            return group(groupNum + 1, status);
+        }
+    }
+
+    status = U_REGEX_UNKNOWN_GROUP_NAME;
+    return UnicodeString();
+}
+
+
+
+// This is only here because groupCount() is a matcher method
+int32_t RegexMatcher::groupIndexFromName(const UnicodeString &groupName,
+                                         UErrorCode &status) const {
+    if (U_FAILURE(fDeferredStatus)) {
+        status = fDeferredStatus;
+        return -1;
+    }
+
+    return fPattern->groupIndexFromName (groupName, status);
+}
+
 
 
 int32_t RegexMatcher::groupCount() const {
@@ -858,7 +924,6 @@
 
 
 
-
 int32_t RegexMatcher::start(int group, UErrorCode &status) const {
     if (U_FAILURE(status)) {
         return -1;
@@ -889,6 +954,32 @@
 
 
 
+int32_t RegexMatcher::start(const UnicodeString &groupName, 
+                            UErrorCode &err) const {
+    if (U_FAILURE(err)) {
+        return -1;
+    }
+    if (fMatch == FALSE) {
+        err = U_REGEX_INVALID_STATE;
+        return -1;
+    }
+
+    int32_t namedGroupCount = fPattern->fNamedGroups->size();
+    int32_t nameIndex;
+    for (nameIndex = 0; nameIndex < namedGroupCount; ++nameIndex) {
+        UnicodeString *name = (UnicodeString *)fPattern->fNamedGroups->elementAt(nameIndex);
+
+        if (*name == groupName) {
+            int32_t groupNum = fPattern->fNamedGroupMap->elementAti(nameIndex);
+            return start(groupNum + 1, err);
+        }
+    }
+
+    err = U_REGEX_UNKNOWN_GROUP_NAME;
+    return -1;
+}
+
+
 //================================================================================
 //
 //    Code following this point in this file is the internal
@@ -1093,6 +1184,9 @@
         fData[i] = 0;
     }
 
+    // A string to hold the name of the capturing group
+    int32_t captureNameIdx = -1;
+
     //
     //  Main loop for interpreting the compiled pattern.
     //  One iteration of the loop per pattern operation performed.
@@ -1192,6 +1286,14 @@
             fp = StateSave(fp, opValue, frameSize, status);
             break;
 
+        case URX_STATE_POP:
+            {
+                // Pop the state without moving the pattern index
+                int32_t nextOp = fp->fPatIdx;
+                fp = (REStackFrame *)fStack->popFrame(frameSize);
+                fp->fPatIdx = nextOp;
+            }
+            break;
 
         case URX_END:
             // The match loop will exit via this path on a successful match,
@@ -1620,6 +1722,17 @@
             }
             break;
 
+        case URX_CONDITION:
+            {
+                U_ASSERT(opValue < frameSize);
+                int32_t groupStartIdx = fp->fExtra[opValue];
+
+                if (groupStartIdx >= 0) {
+                    // This group has been matched, so skip the next instruction
+                    fp->fPatIdx++;
+                }
+            }
+            break;
 
         case URX_JMP:
             fp->fPatIdx = opValue;
